<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: 1.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: 1.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import React, { Component } from "react";
import EntityMetricsFilter from "./EntityMetricsFilters";
import Tabs from "./Tabs";
import Button from "react-bootstrap/Button";
import AxiomMetricsFilters from "./AxiomMetricsFilters";
import ClassExpressionTypeMetricsFilters from "./ClassExpressionTypeMetricsFilters";
import TaxonomyMetricsFilters from "./TaxonomyMetricsFilters";
import OWL2ProfilesAndReasoning from "./OWL2ProfilesAndReasoningMetricsFilters";
import OntologiesTable from "./OntologiesTable";
import AnnotationMetricsFilters from "./AnnotationMetricsFilters";
import DetailMetricsFilters from "./DetailMetricsFilters";
import Modal from "react-bootstrap/Modal";
import ResourceFilter from "./ResourceFilter";

/**
 * Ontology Search based on Given Exact Intervals of Metrics page
 *
 * @component
 */
class _1 extends Component {
  /** @constructor */
  constructor(props) {
    super(props);
    this.state = {
      filters: { selectedResource: "all" },
      data: [],
      showPopup: false,
      popupMessage: "",
      popupTitle: "",
      storageCodes: [],
      ontologiesStats: [],
    };

    this.tableRef = React.createRef();
  }

  /**
   * Fetches initial statistics for metrics and sets the browser tab name
   *
   * @method
   * @async
   */
  async componentDidMount() {
    document.title = "OOSP - Intervals of Metrics";
    let data = [];
    try {
      const res = await fetch(`/getOntolologiesStats/all`, {
        method: "GET",
        headers: {
          "Content-Type": "application/json",
          Accept: "application/json",
        },
      });
      data = await res.json();
      this.setState({ ontologiesStats: data });
    } catch (e) {
      console.error(e);
    }
  }

  /**
   * Scrolls to the table with ontology results
   *
   * @method
   */
  scrollToTable = () =>
    this.tableRef.current.scrollIntoView({ behavior: "smooth" });

  /**
   * Updates filter array according to changes in filters
   *
   * @method
   * @param {Object} filter - filter to be updated
   */
  updateFilters = (filter) => {
    let isAllowed = true;

    for (const item in filter) {
      if (
        filter[item] !== "" &amp;&amp;
        (Number(parseFloat(filter[item])) !== parseFloat(filter[item]) ||
          filter[item] &lt; 0)
      ) {
        isAllowed = false;
        break;
      }
    }
    if (isAllowed) {
      this.setState({ filters: { ...this.state.filters, ...filter } });
    } else {
      this.setState({
        showPopup: true,
        popupTitle: "Wrong value",
        popupMessage: `Please enter number higher than zero or equal to zero.`,
      });
    }
  };

  /**
   * Fetches ontologies based on selected filters
   *
   * @method
   * @async
   */
  getData = async () => {
    try {
      const res = await fetch("/ontologies", {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
          Accept: "application/json",
        },
        body: JSON.stringify(this.state.filters),
      });
      const data = await res.json();
      this.setState(
        {
          data: data,
        },
        () => {
          if (data.length) this.scrollToTable();
        }
      );
    } catch (e) {
      console.log(e);
    }
  };

  /**
   * Fetches metrics statistics when a resource is changed
   *
   * @method
   * @param {String} resource - Selected resource
   * @async
   */
  handleSelectChange = async (resource) => {
    let data = [];
    try {
      const res = await fetch(`/getOntolologiesStats/${resource}`, {
        method: "GET",
        headers: {
          "Content-Type": "application/json",
          Accept: "application/json",
        },
      });
      data = await res.json();
    } catch (e) {
      console.log(e);
    }
    this.setState({
      filters: { ...this.state.filters, selectedResource: resource },
      ontologiesStats: data,
    });
  };

  /**
   * Hides popups
   *
   * @method
   */
  hidePopup = () => {
    this.setState({ showPopup: false });
  };

  /**
   * Resets all filters (except resource)
   *
   * @method
   */
  resetFilters = () => {
    const resource = this.state.filters.selectedResource;
    this.setState({
      filters: { selectedResource: resource },
      data: [],
      randomOntologiesNumber: "",
    });
  };

  /**
   * Renders Ontology Search based on Given Exact Intervals of Metrics component
   *
   * @method
   */
  render() {
    const {
      filters,
      data,
      showPopup,
      popupMessage,
      popupTitle,
      ontologiesStats,
    } = this.state;

    return (
      &lt;div>
        &lt;Modal show={showPopup} onHide={this.hidePopup}>
          &lt;Modal.Header closeButton>
            &lt;Modal.Title>{popupTitle}&lt;/Modal.Title>
          &lt;/Modal.Header>
          &lt;Modal.Body>{popupMessage}&lt;/Modal.Body>
          {/* &lt;Modal.Footer>
          &lt;Button variant="secondary" onClick={handleClose}>Close&lt;/Button>
          &lt;Button variant="primary" onClick={handleClose}>
            Save Changes
          &lt;/Button>
        &lt;/Modal.Footer> */}
        &lt;/Modal>
        &lt;h3>Ontology Search based on Given Exact Intervals of Metrics&lt;/h3>
        &lt;ResourceFilter selectionChanged={this.handleSelectChange} />
        &lt;br />
        &lt;Tabs>
          &lt;div label="Entity">
            &lt;EntityMetricsFilter
              stats={ontologiesStats}
              savedFilters={filters}
              updateFilters={this.updateFilters}
            />
          &lt;/div>
          &lt;div label="Axiom">
            &lt;AxiomMetricsFilters
              stats={ontologiesStats}
              savedFilters={filters}
              updateFilters={this.updateFilters}
            />
          &lt;/div>
          &lt;div label="Class expression type">
            &lt;ClassExpressionTypeMetricsFilters
              stats={ontologiesStats}
              savedFilters={filters}
              updateFilters={this.updateFilters}
            />
          &lt;/div>
          &lt;div label="Taxonomy">
            &lt;TaxonomyMetricsFilters
              stats={ontologiesStats}
              savedFilters={filters}
              updateFilters={this.updateFilters}
            />
          &lt;/div>
          &lt;div label="OWL2 profiles and reasoning">
            &lt;OWL2ProfilesAndReasoning
              stats={ontologiesStats}
              savedFilters={filters}
              updateFilters={this.updateFilters}
            />
          &lt;/div>
          &lt;div label="Annotation">
            &lt;AnnotationMetricsFilters
              stats={ontologiesStats}
              savedFilters={filters}
              updateFilters={this.updateFilters}
            />
          &lt;/div>
          &lt;div label="Detail">
            &lt;DetailMetricsFilters
              stats={ontologiesStats}
              savedFilters={filters}
              updateFilters={this.updateFilters}
            />
          &lt;/div>
        &lt;/Tabs>
        &lt;div className="filter-btn-group">
          &lt;Button onClick={this.getData}>
            Get Ontology Set according to Current Ontology Criteria Selection
          &lt;/Button>

          &lt;Button
            variant="danger"
            onClick={this.resetFilters}
            className="reset-filters-btn"
          >
            Reset
          &lt;/Button>
        &lt;/div>

        &lt;br />

        &lt;OntologiesTable
          data={data}
          page="1"
          filters={filters}
          tableRef={this.tableRef}
        />
      &lt;/div>
    );
  }
}

export default _1;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="-_1.html">_1</a></li><li><a href="-_2.html">_2</a></li><li><a href="AnnotationMetricsFilters.html">AnnotationMetricsFilters</a></li><li><a href="AnnotationsDistribution.html">AnnotationsDistribution</a></li><li><a href="AxiomFrequencyDistribution.html">AxiomFrequencyDistribution</a></li><li><a href="AxiomMetricsFilters.html">AxiomMetricsFilters</a></li><li><a href="AxiomTypesDistribution.html">AxiomTypesDistribution</a></li><li><a href="ChartPopup.html">ChartPopup</a></li><li><a href="ClassesFrequencyDistribution.html">ClassesFrequencyDistribution</a></li><li><a href="ClassExpressionTypeMetricsFilters.html">ClassExpressionTypeMetricsFilters</a></li><li><a href="DetailMetricsFilters.html">DetailMetricsFilters</a></li><li><a href="DLConstructsDistribution.html">DLConstructsDistribution</a></li><li><a href="DomainRangeDefinitionDistribution.html">DomainRangeDefinitionDistribution</a></li><li><a href="EntitiyMetricsFilters.html">EntitiyMetricsFilters</a></li><li><a href="Home.html">Home</a></li><li><a href="InstancesFrequencyDistribution.html">InstancesFrequencyDistribution</a></li><li><a href="Navigation.html">Navigation</a></li><li><a href="OntologiesTableClass.html">OntologiesTableClass</a></li><li><a href="OWL2ProfilesAndReasoning.html">OWL2ProfilesAndReasoning</a></li><li><a href="OWL2ProfilesDistribution.html">OWL2ProfilesDistribution</a></li><li><a href="ResourceFilter.html">ResourceFilter</a></li><li><a href="Tab.html">Tab</a></li><li><a href="Tabs.html">Tabs</a></li><li><a href="TaxonomyMetricsFilters.html">TaxonomyMetricsFilters</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.6</a> on Sun Apr 11 2021 17:29:26 GMT+0200 (stredoeurópsky letný čas)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
